#ifndef ADV_CONFIG_H_
#define ADV_CONFIG_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <inttypes.h>

#ifndef SENSOR_DATA_LEN
#define SENSOR_DATA_LEN 16
#endif
extern uint8_t sensor_data[SENSOR_DATA_LEN];

#define SBOX_CONFIG_DEFAULT_TIMEOUT 15
#define SBOX_CONFIG_DEFAULT_SLEEP 1000
#define SBOX_ACCEL_DEFAULT_SENSITIVITY 7
#define SBOX_ACCEL_DEFAULT_FREQ 15

#define SBOX_CONFIG_WAKEUP_ACCEL 1
#define SBOX_CONFIG_WAKEUP_TILT_COUNTER 2
#define SBOX_CONFIG_WAKEUP_IN_COUNTER 3
#define SBOX_CONFIG_WAKEUP_ONOFF 4
#define SBOX_CONFIG_WAKEUP_RS232 5
#define SBOX_CONFIG_WAKEUP_RS485 6
#define SBOX_CONFIG_WAKEUP_NFC 7
#define SBOX_CONFIG_WAKEUP_1WIRE 8
#define SBOX_CONFIG_WAKEUP_ANALOG_IN 9
#define SBOX_CONFIG_WAKEUP_DC_IN 10
#define SBOX_CONFIG_WAKEUP_20MA 11

#define SBOX_CONFIG_LPCOMP_DETECT_MASK 0x30
#define SBOX_CONFIG_LPCOMP_HYST_MASK 0x40
#define SBOX_CONFIG_LPCOMP_REF_MASK 0x0f

#define SBOX_CONFIG_DEFAULT_WAKEUP SBOX_CONFIG_WAKEUP_ACCEL

#define SBOX_CONFIG_SENSOR_ACCEL 1
#define SBOX_CONFIG_SENSOR_GYRO 2
#define SBOX_CONFIG_SENSOR_ANALOG_IN 3
#define SBOX_CONFIG_SENSOR_DC_IN 4
#define SBOX_CONFIG_SENSOR_BATTERY 5
#define SBOX_CONFIG_SENSOR_20MA 6
#define SBOX_CONFIG_SENSOR_TILT_COUNTER 7
#define SBOX_CONFIG_SENSOR_IN_COUNTER 8
#define SBOX_CONFIG_SENSOR_RS232 9
#define SBOX_CONFIG_SENSOR_RS485 10
#define SBOX_CONFIG_SENSOR_NFC 11
#define SBOX_CONFIG_SENSOR_1WIRE 12
#define SBOX_MESSAGE_THREAD 13

#define SBOX_SUSPEND_FRAME 254


#define SBOX_CONFIG_PARSE_OK 0
#define SBOX_CONFIG_PARSE_ERROR_UNKNOWN_PARAM -1
#define SBOX_CONFIG_PARSE_ERROR_INVALID_ARG -2
void setConfigBit(uint16_t *dest, int bitNumber, int val);
int parse_config(char buf[]);

#ifdef __cplusplus
}
#endif

#endif
