/*
 *
 * Copyright (c) [2022] by InvenSense, Inc.
 * 
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
 
//#include "Arduino.h"
#include <inttypes.h>
#include <zephyr/kernel.h>

void inv_imu_sleep_us(uint32_t us)
{
    k_usleep(us);    
}



static inline uint32_t micros(void)
{
    // Pobierz liczbę cykli zegara systemowego
    uint32_t cycles = k_cycle_get_32();

    // Przekształć liczbę cykli na mikrosekundy (przy założeniu częstotliwości zegara 1 MHz)
    uint32_t microseconds = cycles / 1000; // 1 mikrosekunda = 1000 cykli

    return microseconds;
}

uint64_t inv_imu_get_time_us(void)
{
    return (uint64_t)micros();
}